"""Adapters around actual Fnorb stubs so they behave like the python
 mapping. These Adapters are for the Ensembl IDL interface.

Each class does two things:
1. Inherets from the actual skel, so that the inheritence in the main code
can be uniform.

2. Defines a _this() function which creates a unique object ref for a
class object, and registers it with the boa.
"""
# import the General Adapter code
from BioCorba.Adapters.Generic import GenericFnorbAdapter

# import the actual skeleton code
import BioCorba.org_skel.ensembl_skel as skel_base

class Exon(skel_base.Exon, GenericFnorbAdapter):
    unique_name = 'Exon'

class Translation(skel_base.Translation, GenericFnorbAdapter):
    unique_name = 'Translation'

class Transcript(skel_base.Transcript, GenericFnorbAdapter):
    unique_name = 'Transcipt'
        
class Gene(skel_base.Gene, GenericFnorbAdapter):
    unique_name = 'Gene'

class GeneIterator(skel_base.GeneIterator, GenericFnorbAdapter):
    unique_name = 'GeneIterator'

class VirtualContig(skel_base.VirtualContig, GenericFnorbAdapter):
    unique_name = 'VirtualContig'

class GeneFactory(skel_base.GeneFactory, GenericFnorbAdapter):
    unique_name = 'GeneFactory'

class VirtualContigFactory(skel_base.VirtualContigFactory,
                           GenericFnorbAdapter):
    unique_name = 'VirtualContigFactory'

class EnsemblFactory(skel_base.EnsemblFactory, GenericFnorbAdapter):
    unique_name = 'EnsemblFactory'
