#!/usr/bin/env python
"""Example client to demonstrate connecting to a SecretMessage server.
"""
# standard modules
import urllib

# omniORB
from omniORB import CORBA

# skeleton code generated by the IDL compiler
import messenger

# --- Get the IOR from the remote server
SECRET_MESSAGE_URL = "http://industry.ebi.ac.uk/~alan/IOR/" + \
                     "message.SecretMessage-Server.ior"

ior_handle = urllib.urlopen(SECRET_MESSAGE_URL)
secret_message_ior = ior_handle.read()
ior_handle.close()

# --- Connect with the remote server and get the secret message
orb = CORBA.ORB_init([], CORBA.ORB_ID)
secret_message_server = orb.string_to_object(secret_message_ior)

print "The secret message is...", secret_message_server.get_message()



